// `ƌXw̐ڐvZ
// `line-XWϊĒ_ƂČvZ܂B
// `̒_͐ڐo
// _x̒ĺA덷傫Ȃ܂A_͐ɐ邽߂łB
// Otŏɍ}āA͈͂̊mF܂B
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, VCLTee.Series,
  Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, VCLTee.TeEngine, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Series3: TPointSeries;
    Series4: TPointSeries;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    BitBtn2: TBitBtn;
    CheckBox1: TCheckBox;
    LabeledEdit5: TLabeledEdit;
    Series2: TLineSeries;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit2Change(Sender: TObject);
    procedure LabeledEdit3Change(Sender: TObject);
    procedure LabeledEdit4Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure LabeledEdit5Change(Sender: TObject);
  private
    { Private 錾 }
    procedure chart_graph(gl, gr: double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


// x, y  W
// q : px(rad)
// xt, yt ϊW
procedure transformation(x, y, q : double; var xt, yt : double);
var
  qt, ysx, l : double;
begin
  if x <> 0 then begin
    ysx := y / x;
    qt := arctan(ysx);
  end
  else qt := pi / 2;
  qt := qt + q;
  l := x * x + y * y;
  l := Sqrt(l);
  xt := cos(qt) * l;
  yt := sin(qt) * l;
end;

// ֐f(x)̌vZ@`
// f(x) = (x-3)^2 - 2
// f'(x) = x / 2 - 6
// X̐ڐxW@= x/2-6,  x= (+6)/2
function f(x: double): double;
begin
  result := (x - 3) * (x - 3) - 2;
//  result := x * x;
  if form1.CheckBox1.Checked = true then result := -result;
end;

// Ot͈͓@XmF
// gl Ot[
// gr OtE[
// a X
// `FbNsb`
function tiltcheck(gl, gr, a, p: double): boolean;
var
  sx, ex, sy, ey, sa, ea : double;
  n, i : integer;
begin
  result := false;
  p := p / 10;
  n := round((gr - gl) / p);
  sx := gl;
  sy := f(gl);
  ex := gl + p;
  ey := f(ex);
  sa := (ey - sy) / (ex - sx) - a;
  for i := 2 to n do begin
    sx := ex;
    sy := ey;
    ex := gl + i * p;
    ey := f(ex);
    ea := (ey - sy) / (ex - sx) - a;
    if ea * sa <= 0 then begin
      result := true;
      break;
    end;
    sa := ea;
  end;
end;

// 
procedure line_segment(x, y, a, gl, gr: double);
var
  c : double;
begin
  c := y - a * x;
  y := a * gl + c;
  form1.Series2.AddXY(gl, y);
  y := a * gr + c;
  Form1.Series2.AddXY(gr, y);
  Form1.Memo1.Lines.Append('ڐ');
  if c >= 0 then
    Form1.Memo1.Lines.Append(' y = ' + floatTostr(a) + 'x + ' + floatTostr(c))
  else
    Form1.Memo1.Lines.Append(' y = ' + floatTostr(a) + 'x ' + floatTostr(c))
end;

// [gl,gr]̊֐f(x)̃Ot}
procedure TForm1.chart_graph(gl, gr: double);
const
  n = 100;
var
  x, xs, xe, dx: double;
  y : double;
  i : integer;
begin
  series1.clear;
  series2.clear;
  series3.clear;
  series4.clear;
  if gl = gr then exit;                     // ͈͂[I
  xs := gl;
  xe := gr;
  dx := (xe - xs) / n;
  for i := 0 to n do begin
    x := xs + i * dx;
    y := f(x);
    series1.AddXY(x, y);
  end;
end;

// _̋ߎlvZ
function bisection_method(a, p, q, epsilon: double; var loop: integer): double;
var
  fn, fa, fnt, fat: double;
  nt, at : double;
  chf : boolean;
begin
  q := arctan(q);
  fn := f(a);                           // _vZ
  transformation(a, fn, q, at, fnt);
  a := a + p;                           // ̓_
  fa := f(a);                           // ̓_vZ
  transformation(a, fa, q, nt, fat);
  chf := false;
  if form1.CheckBox1.Checked = true then begin
    if fnt > fat then chf := true;        // _
  end
  else begin
    if fnt < fat then chf := true;        // _   ŉ_
  end;
  if chf then begin
    result := 0;
    exit;
  end;
  // _̌vZ
  repeat
    chf := false;
    fat := fnt;                           // O̒lۑ
    a := a + p;                           // ̌vZ_
    fn := f(a);                           // ̓_vZ
    transformation(a, fn, q, nt, fnt);
    if form1.CheckBox1.Checked = true then begin
      if fnt < fat then chf := true;      // _
    end
    else begin
      if fnt > fat then chf := true;      // _   ŉ_
    end;
    if chf then begin
      a := a - p - p;                     // 2sb`߂
      p := p / 4;
      fn := f(a);                         // ̒lČvZ
      transformation(a, fn, q, nt, fnt);
    end;
    inc(loop);
  until (p < epsilon * (abs(a) + 1)) or (loop > 500);
  result := a;
end;

// vZs
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  a, p, alpha, y, q, gr, gl : double;
  loop : integer;
  epsilon, tmp : double;
begin
  q := strTofloat(labelededit5.Text);
  a := strTofloat(labelededit1.Text);
  p := strTofloat(labelededit2.Text);
  gl := strTofloat(labelededit3.Text);
  gr := strTofloat(labelededit4.Text);
  memo1.Clear;
  // lvZ
  epsilon := 1;
  repeat
    epsilon := epsilon / 2;
    tmp := 1 + epsilon;
  until tmp = 1;
  epsilon := epsilon * 2;
  // `̌vZ
  loop := 0;
  alpha := bisection_method(a, p, -q, epsilon, loop);
  if loop = 0 then begin
    application.MessageBox('l̈ʒuɊԈႢA̓sb`傫܂B','',0);
    exit;
  end;
  // Z
  y := f(alpha);
  // vZʕ\
  series4.AddXY(alpha, y);
  memo1.Lines.Append('f(x) = (x - 3)^2 - 2');
  memo1.Lines.Append('[v ' + intTostr(loop));
  memo1.Lines.Append('l');
  memo1.Lines.Append(floatTostr(epsilon));
  memo1.Lines.Append('x= ' +floatTostr(alpha));
  memo1.Lines.Append('Z y = f(x)');
  memo1.Lines.Append('y= ' +floatTostr(y));
  line_segment(alpha, y, q, gl, gr);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  gl, gr : double;
  ch : integer;
  a, p, y, q : double;
begin
  val(labelededit3.Text, gl, ch);
  if ch <> 0 then begin
    application.MessageBox('Ot͈͍ɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit4.Text, gr, ch);
  if ch <> 0 then begin
    application.MessageBox('Ot͈͉EɊԈႢL܂B','',0);
    exit;
  end;
  if gr <= gl then begin
    application.MessageBox('Ot͈͉Eɂ͍傫ĉB','',0);
    exit;
  end;

  chart_graph(gl, gr);
  application.ProcessMessages;

  val(labelededit1.Text, a, ch);
  if ch <> 0 then begin
    application.MessageBox('laɊԈႢL܂B','',0);
    exit;
  end;
  val(labelededit2.Text, p, ch);
  if ch <> 0 then begin
    application.MessageBox('ԊupɊԈႢL܂B','',0);
    exit;
  end;
  if (a < gl) or (a > gr) then begin
    application.MessageBox('laOt͈̔͊OłB','',0);
    exit;
  end;
  if a > (gr - gl) / 2 + gl then begin
    application.MessageBox('la͍ɂĉB','',0);
    exit;
  end;
  val(labelededit5.Text, q, ch);
  if ch <> 0 then begin
    application.MessageBox('̌XɊԈႢL܂B','',0);
    exit;
  end;
  y := f(a);
  series3.AddXY(a, y);
  application.ProcessMessages;
  if p > (gr - gl) / 2 then begin
    application.MessageBox('Ԋup傫܂B','',0);
    exit;
  end;
  if p <= 0 then begin
    application.MessageBox('Ԋup̓[傫ĉB','',0);
    exit;
  end;
  y := f(a + p);
  series4.AddXY(a + p, y);

  if not tiltcheck(a, gr, q, p) then begin
    application.MessageBox('vZ͈͓(l`Ot͈͉E)Ɏw̌X͗L܂B','',0);
    exit;
  end;
  application.ProcessMessages;
  bitbtn1.Enabled := True;
end;

procedure TForm1.LabeledEdit1Change(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.LabeledEdit2Change(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.LabeledEdit3Change(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.LabeledEdit4Change(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.LabeledEdit5Change(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  bitbtn1.Enabled := false;
end;


end.
